
package de.ivu.elect.presentation.stimmeingabe.action;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationConversationStore;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationTemplateConversationStore;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration;
import org.apache.deltaspike.core.api.scope.ConversationGroup;

@Named(StimmeingabePlausiKonfigurationResetToDefaultAction.COMPONENT_NAME)
public class StimmeingabePlausiKonfigurationResetToDefaultAction extends AbstractStimmeingabePlausiKonfigurationAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmeingabePlausiKonfigurationResetToDefaultAction";

  @Inject
  @ConversationGroup(StimmeingabePlausiKonfigurationTemplateConversationStore.class)
  private transient StimmeingabePlausiKonfigurationTemplateConversationStore stimmeingabePlausiKonfigurationTemplateConversationStore;

  public StimmeingabePlausiKonfigurationResetToDefaultAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.STIMMEINGABE_PLAUSI_DELETE;
  }

  @Override
  protected boolean isDisabledInternal(StimmeingabePlausiKonfiguration stimmeingabePlausiKonfiguration) {
    return super.isDisabledInternal(stimmeingabePlausiKonfiguration) || !stimmeingabePlausiKonfiguration.isStimmeingabePlausiKonfigurationDefaultOverridden();
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  protected String doIt(StimmeingabePlausiKonfiguration stimmeingabePlausiKonfiguration) {
    stimmeingabePlausiKonfigurationTemplateConversationStore.setTemplate(stimmeingabePlausiKonfiguration);

    // Return to current page and display the dialog!
    return null;
  }

  @Override
  public String getDialogName() {
    return "ResetToDefaultConfirm";
  }

  @Override
  public String getLabelKey() {
    return "stimmeingabe.plausi.konfiguration.action.reset.to.default";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconRecover();
  }
}
